#include <semaphore.h>
#include <pthread.h>
#include <unistd.h>
#include <stdint.h>
#include <stdio.h>
#include "list.hpp"
#include "globals.hpp"
#include "producer.hpp"
#include "consumer.hpp"
#include "transformer.hpp"

// Create all of memory
block memory[N] = {0};
// create the three lists
list lists[3] = {0};
list *freelist = &lists[0], *list1 = &lists[1], *list2 = &lists[2];

// count semaphores
sem_t semfl, seml1, seml2;
// binary semaphores
sem_t mutfl, mutl1, mutl2;

int main (int argc, char* argv[]) {
   // initialize the freelist
   list_init(freelist, memory, N);

   //TODO: Implement a semaphore solution to the problem
   sem_init(&semfl, 0, freelist->length);
   sem_init(&seml1, 0, 0);
   sem_init(&seml2, 0, 0);
   sem_init(&mutfl, 0, 1);
   sem_init(&mutl1, 0, 1);
   sem_init(&mutl2, 0, 1);

   //TODO: Use pthreads to split execution
   // Make some pthreads
   pthread_t thread1, thread2, thread3;

   // Create thread1 as producer
   pthread_create(&thread1, NULL, producer, NULL);

   // Create thread2 as transformer
   pthread_create(&thread2, NULL, transformer, NULL);

   // Create thread3 as consumer
   pthread_create(&thread3, NULL, consumer, NULL);

   while (true) {
      list_print(freelist);
      list_print(list1);
      list_print(list2);
      sleep(1);
   }
   // Wait for them to finish
   pthread_join(thread1, NULL);
   pthread_join(thread2, NULL);
   pthread_join(thread3, NULL);

}
