#include <semaphore.h>
#include <stdint.h>
#include <stdio.h>
#include "list.hpp"
#include "globals.hpp"
#include "producer.hpp"
#include "consumer.hpp"
#include "transformer.hpp"

// Create all of memory
block memory[N] = {0};
// create the three lists
list lists[3] = {0};
list *freelist = &lists[0],
     *list1 = &lists[1],
     *list2 = &lists[2];

// count semaphores
sem_t semfl, seml1, seml2;
// binary semaphores
sem_t mutfl, mutl1, mutl2;

void producer_test();
void transfer_test();
void consumer_test();

int main(int argc, char *argv[]) {
   list_init(freelist, memory, N);
   list_print(freelist);
   //producer_test();
   //transfer_test();
   //consumer_test();
}

void producer_test() {
   printf("Starting producer_test:\n");\
   producer(NULL);
   list_print(freelist);
   list_print(list1);
   list_print(list2);
   printf("Ending producer_test\n");
}

void transfer_test() {
   printf("Starting transfer_test:\n");
   transformer(NULL);
   list_print(freelist);
   list_print(list1);
   list_print(list2);
   printf("Ending transfer_test\n");
}

void consumer_test() {
   printf("Starting consumer_test:\n");
   consumer(NULL);
   list_print(freelist);
   list_print(list1);
   list_print(list2);
   printf("Ending consumer_test\n");
}

/*
int movement_test () {

   // Create all of memory
   block memory[N] = {0};
   // create the three lists
   list freelist = {0}, list1 = {0};
   // initialize the freelist
   list_init(&freelist, memory, N);

   // print the lists
   std::printf("Lists:\n");
   list_print(&freelist);
   list_print(&list1);

   // move a block
   block *b;
   while (b = list_unlink(&freelist))
   {
      list_link(&list1, b);
   }
   // print the lists again (should be reversed order)
   std::printf("Lists, again:\n");
   list_print(&freelist);
   list_print(&list1);
   return 1;
}
*/