#include <semaphore.h>
#include <unistd.h>
#include "list.hpp"
#include "globals.hpp" // freelist list1 list2
#include "transformer.hpp"

void transform(block* x, block* y);

void *transformer (void *) {
   block *x, *y;
   while (true) {
      sem_wait(&seml1); // decrease seml1
      sem_wait(&mutl1);
      x = list_unlink(list1);
      sem_post(&mutl1);

      sem_wait(&semfl); // decrease semfl
      sem_wait(&mutfl);
      y = list_unlink(freelist);
      sem_post(&mutfl);

      //* use block x to produce info in y
      transform(x, y);

      sem_wait(&mutfl);
      list_link(freelist, x);
      sem_post(&mutfl);
      sem_post(&semfl);

      sem_wait(&mutl2);
      list_link(list2, y);
      sem_post(&mutl2);
      sem_post(&seml2);
   }
   return nullptr;
}

void transform(block *x, block *y) {
   x->data ^= y->data;
   y->data ^= x->data;
   x->data ^= y->data;
   usleep(55);
   return;
}
